Minimum Inversion Number HDU - 1394
Time limit
1000 ms
Memory limit
32768 kB
The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj.
For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seqence, we will obtain another sequence. There are totally n such sequences as the following:
a1, a2, ..., an-1, an (where m = 0 - the initial seqence)
a2, a3, ..., an, a1 (where m = 1)
a3, a4, ..., an, a1, a2 (where m = 2)
...
an, a1, a2, ..., an-1 (where m = n-1)
You are asked to write a program to find the minimum inversion number out of the above sequences.
Input
The input consists of a number of test cases. Each case consists of two lines: the first line contains a positive integer n (n <= 5000); the next line contains a permutation of the n integers from 0 to n-1.
Output
For each case, output the minimum inversion number on a single line.
Sample Input
10
1 3 6 9 0 8 5 7 4 2
Sample Output
16
最好用线段树,不过暴力跑也可以过。
由于懒的写线段树所以我用的是暴力的方法,这里也只有暴力的代码。
思路:
以1 3 6 9 0 8 5 7 4 2为例,这十个数中比1小的有一个,比1大的有8个,
所以当1换到最后时此时关于1的逆序数从一个变成了八个,3类似,依次往下推直到以2为首,则过程中的最小值即为结果。
代码:
#include <iostream>
#include <cstdio>
#include <algorithm>
using namespace std;
int board[5005][2];//分别记录每个点的值和每个点在数列中比其小的点的数量。
int main(){
int N;
while(scanf("%d",&N)!=EOF){
int sum = 0;//数列初始时的总逆序数
for(int i=0 ; i<N ; i++)scanf("%d",&board[i][0]);
for(int i=0 ; i<N ; i++){
int mid = 0;
for(int j=0 ; j<i ; j++){
if(board[j][0]<board[i][0])mid++;
}
board[i][1] = mid;
}
for(int i=0 ; i<N ; i++){
int mid = 0;
for(int j=i+1 ; j<N ; j++){
if(board[j][0]<board[i][0])mid++;
}
board[i][1] += mid;
sum += mid;
}
int re = sum;
for(int i=0 ; i<N ; i++){
sum = sum-board[i][1] + N-board[i][1]-1;
re = min(re,sum);
}
printf("%d\n",re);
}
return 0;
}